﻿using UnityEngine;
using UnityEngine.UI;
using HarmonyLib;
using System.Collections.Generic;
using System;
using System.IO;
using System.Linq;
using UnityEngine.AzureSky;
using Steamworks;

public class StatisticMod : Mod
{
    private Harmony harmony;
    static CanvasHelper _can = null;
    public static CanvasHelper canvas {
        get
        {
            if (_can == null)
                _can = ComponentManager<CanvasHelper>.Value;
            return _can;
        }
    }
    static string configPath = Path.Combine(SaveAndLoad.WorldPath, "StatisticMod.json");
    public static JSONObject Config = getSaveJson();
    public static List<HealthBar> bars;
    public static List<Network_Entity> ents;
    public static List<damageIndicator> pops;
    public static TimeBar time;
    public static float playerHealthUpdateTime = 0;
    public static float sharkTime = 0;
    public static short defaultMessagesOffset = (short) Enum.GetNames(typeof(Messages)).Length;
    public static short CustomMessageID = short.MaxValue - 5;
    public static List<HUDEquipmentDisplay> equipDisplay;
    public static bool updatePlayerHealth
    {
        get
        {
            playerHealthUpdateTime += Time.deltaTime;
            if (playerHealthUpdateTime > 1)
            {
                playerHealthUpdateTime--;
                return true;
            }
            return false;
        }
    }
    public static float aspectRatio
    {
        get
        {
            return (float)Screen.width / (float)Screen.height;
        }
    }
    public static GameObject dmgDisplay
    {
        set
        {
            dmgObject = value;
            dmgOffset = dmgObject.GetComponent<RectTransform>();
            dmgStart = dmgOffset.anchoredPosition;
            dmgText = dmgObject.GetComponent<Text>();
        }
        get
        {
            return dmgObject;
        }
    }
    public static RectTransform dmgOffset;
    public static Vector2 dmgStart;
    public static Text dmgText;
    private static GameObject dmgObject;
    public static Text statHeT;
    public static Text statHuT;
    public static Text statThT;
    public static sharkIndicator sharkI;
    public static float dmgTime = 0f;
    static List<int> storyNotes = new int[] { 901 , 2, 17, 902 , 43, 53 }.ToList();
    static List<string> objectiveNames = new string[] { "Build Reciever", "Radio Tower", "Cruise Ship", "Balboa Island", "Caravan Town", "Tangaroa", "COMING SOON" }.ToList();
    public static bool timeIsClock
    {
        get
        {
            int s = clockSetting;
            if (s == 3)
            {
                Raft raft = ComponentManager<Raft>.Value;
                if (raft != null)
                {
                    Clock clock = raft.GetComponentInChildren<Clock>();
                    return clock != null;
                }
            }
            return s == 2;
        }
    }
    public static int clockSetting
    {
        get
        {
            if (Config.IsNull || !Config.HasField("clockMode"))
                return 1;
            return (int)Config.GetField("clockMode").n;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("clockMode"))
                Config.SetField("clockMode", value);
            else
                Config.AddField("clockMode", value);
        }
    }
    public static bool showFullBars
    {
        get
        {
            if (Config.IsNull || !Config.HasField("fullBarsVisible"))
                return true;
            return Config.GetField("fullBarsVisible").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("fullBarsVisible"))
                Config.SetField("fullBarsVisible", value);
            else
                Config.AddField("fullBarsVisible", value);
        }
    }
    public static bool roundStats
    {
        get
        {
            if (Config.IsNull || !Config.HasField("roundStats"))
                return false;
            return Config.GetField("roundStats").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("roundStats"))
                Config.SetField("roundStats", value);
            else
                Config.AddField("roundStats", value);
        }
    }
    public static bool showWeather
    {
        get
        {
            if (Config.IsNull || !Config.HasField("showWeather"))
                return true;
            return Config.GetField("showWeather").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("showWeather"))
                Config.SetField("showWeather", value);
            else
                Config.AddField("showWeather", value);
        }
    }
    public static bool showSharkRespawn
    {
        get
        {
            if (Config.IsNull || !Config.HasField("showShark"))
                return true;
            return Config.GetField("showShark").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("showShark"))
                Config.SetField("showShark", value);
            else
                Config.AddField("showShark", value);
        }
    }
    public static bool showHUDEquipment
    {
        get
        {
            if (Config.IsNull || !Config.HasField("showEquip"))
                return true;
            return Config.GetField("showEquip").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("showEquip"))
                Config.SetField("showEquip", value);
            else
                Config.AddField("showEquip", value);
        }
    }
    public static bool showStoryObjective
    {
        get
        {
            if (Config.IsNull || !Config.HasField("showStory"))
                return true;
            return Config.GetField("showStory").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("showStory"))
                Config.SetField("showStory", value);
            else
                Config.AddField("showStory", value);
        }
    }
    public static bool showDurability
    {
        get
        {
            if (Config.IsNull || !Config.HasField("showDurability"))
                return true;
            return Config.GetField("showDurability").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("showDurability"))
                Config.SetField("showDurability", value);
            else
                Config.AddField("showDurability", value);
        }
    }
    public static bool showFoundations
    {
        get
        {
            if (Config.IsNull || !Config.HasField("showFoundations"))
                return true;
            return Config.GetField("showFoundations").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("showFoundations"))
                Config.SetField("showFoundations", value);
            else
                Config.AddField("showFoundations", value);
        }
    }
    public static float barDrawDistance
    {
        get
        {
            if (Config.IsNull || !Config.HasField("barDrawDistance"))
                return 10;
            return Config.GetField("barDrawDistance").n;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("barDrawDistance"))
                Config.SetField("barDrawDistance", value);
            else
                Config.AddField("barDrawDistance", value);
        }
    }
    public static float HUDPositionX
    {
        get
        {
            if (Config.IsNull || !Config.HasField("HUDPositionX"))
                return 50;
            return Config.GetField("HUDPositionX").n;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("HUDPositionX"))
                Config.SetField("HUDPositionX", value);
            else
                Config.AddField("HUDPositionX", value);
        }
    }
    public static float HUDPositionY
    {
        get
        {
            if (Config.IsNull || !Config.HasField("HUDPositionY"))
                return 50;
            return Config.GetField("HUDPositionY").n;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("HUDPositionY"))
                Config.SetField("HUDPositionY", value);
            else
                Config.AddField("HUDPositionY", value);
        }
    }

    public static JSONObject exclusions
    {
        get
        {
            if (Config.IsNull || !Config.HasField("exclude"))
                return new JSONObject();
            return Config.GetField("exclude");
        }
        set
        {
            if (Config.IsNull || !Config.HasField("exclude"))
            {
                Config.AddField("exclude", value);
                return;
            }
            Config.SetField("exclude", value);
        }
    }
    public void Start()
    {
        harmony = new Harmony("com.aidanamite.StatisticMod");
        harmony.PatchAll();
        equipDisplay = new List<HUDEquipmentDisplay>();
        _can = ComponentManager<CanvasHelper>.Value;
        bars = new List<HealthBar>();
        ents = new List<Network_Entity>();
        pops = new List<damageIndicator>();
        Log("Mod has been loaded!");
    }

    public void Update()
    {
        NetworkMessage netMessage = RAPI.ListenForNetworkMessagesOnChannel(healthCall.ChannelID);
        if (netMessage != null)
        {
            CSteamID id = netMessage.steamid;
            Message message = netMessage.message;
            if (message.Type == (Messages)healthCall.ID)
            {
                healthCall msg = message as healthCall;
                Network_Player remotePlayer = ComponentManager<Semih_Network>.Value.GetPlayerFromID(id);
                foreach (Network_Entity ent in ents)
                    if (ent.ObjectIndex == remotePlayer.ObjectIndex)
                    {
                        ent.stat_health.Value = msg.health;
                        break;
                    }
            }
        }
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll();
        Log("Mod has been unloaded!");
    }

    public override void WorldEvent_WorldUnloaded()
    {
        while (equipDisplay.Count > 0)
        {
            equipDisplay[0].Destroy();
            equipDisplay.RemoveAt(0);
        }
        while (pops.Count > 0)
        {
            pops[0].Destroy();
            pops.RemoveAt(0);
        }
    }

    public static void Log(object message)
    {
        Debug.Log("[Statistic Mod]: " + message.ToString());
    }

    public static void showCrosshairText(string text)
    {
        canvas.displayTextManager.ShowText(text);
    }

    public static GameObject CreateText(Transform canvas_transform, float x, float y, string text_to_print, int font_size, Color text_color, float width, float height, Font font, string name = "Text")
    {
        GameObject UItextGO = new GameObject("Text");
        UItextGO.transform.SetParent(canvas_transform, false);
        RectTransform trans = UItextGO.AddComponent<RectTransform>();
        trans.sizeDelta = new Vector2(width, height);
        trans.anchoredPosition = new Vector2(x, y);
        Text text = UItextGO.AddComponent<Text>();
        text.text = text_to_print;
        text.font = font;
        text.fontSize = font_size;
        text.color = text_color;
        text.name = name;
        Shadow shadow = UItextGO.AddComponent<Shadow>();
        shadow.effectColor = new Color();
        return UItextGO;
    }
    public static void AddTextShadow(GameObject textObject, Color shadowColor, Vector2 shadowOffset)
    {
        Shadow shadow = textObject.AddComponent<Shadow>();
        shadow.effectColor = shadowColor;
        shadow.effectDistance = shadowOffset;
    }
    public static void CopyTextShadow(GameObject textObject, GameObject shadowSource)
    {
        Shadow sourcesShadow = shadowSource.GetComponent<Shadow>();
        if (sourcesShadow == null)
            sourcesShadow = shadowSource.GetComponentInChildren<Shadow>();
        AddTextShadow(textObject, sourcesShadow.effectColor, sourcesShadow.effectDistance);
    }
    public static GameObject CreateLine(Canvas canvas, float length, float width, float x, float y, Color lineColor, float angle)
    {
        GameObject lineContainer = new GameObject();
        lineContainer.transform.SetParent(canvas.transform, false);
        RectTransform trans = lineContainer.AddComponent<RectTransform>();
        trans.sizeDelta = canvas.pixelRect.size;
        trans.anchoredPosition = new Vector2(0, 0);
        UILine.setCreationValues(new Vector2(x, y), length, width, angle);
        UILine lineObj = lineContainer.AddComponent<UILine>();
        lineObj.color = lineColor;
        return lineContainer;
    }

    [ConsoleCommand(name: "setClock", docs: "Syntax: 'setClock <none|bar|clock|auto>'  Changes the display type of the clock")]
    public static string MyCommand(string[] args)
    {
        if (args.Length < 1)
            return "Not enough arguments";
        if (args.Length > 1)
            return "Too many arguments";
        args[0] = args[0].ToLower();
        int ind = new string[] { "none", "bar", "clock", "auto" }.ToList().IndexOf(args[0]);
        if (ind >= 0)
        {
            clockSetting = ind;
            saveJson(Config);
            if (ind == 3)
                return "Time display is now automatic";
            return "Time display is now " + (ind > 0 ? "a " : "") + ToTitle(args[0]);
        }
        return args[0] + " is not valid";
    }

    [ConsoleCommand(name: "showHealth", docs: "Syntax: 'showHealth <animal>'  Enables floating health bars for the specified mob")]
    public static string MyCommand2(string[] args)
    {
        if (args.Length < 1)
            return "Not enough arguments";
        if (args.Length > 1)
            return "Too many arguments";
        args[0] = args[0].ToLower();
        if (removeExclusion(args[0]))
            return ToTitle(args[0]) + " are now showing health bars";
        return ToTitle(args[0]) + " are already showing health bars";
    }

    [ConsoleCommand(name: "hideHealth", docs: "Syntax: 'hideHealth <animal>'  Disables floating health bars for the specified mob")]
    public static string MyCommand3(string[] args)
    {
        if (args.Length < 1)
            return "Not enough arguments";
        if (args.Length > 1)
            return "Too many arguments";
        args[0] = args[0].ToLower();
        if (addExclusion(args[0]))
            return ToTitle(args[0]) + " are no longer showing health bars";
        return ToTitle(args[0]) + " already don't show health bars";
    }

    [ConsoleCommand(name: "show", docs: "Syntax: 'show <GUI Aspect>'  Enables a part of the Statistic Mod GUI elements")]
    public static string MyCommand4(string[] args)
    {
        if (args.Length < 1)
            return "Not enough arguments";
        if (args.Length > 1)
            return "Too many arguments";
        args[0] = args[0].ToLower();
        if (args[0] == "weather")
            return "Weather is " + (setWeatherVisible(true) ? "now" : "already") + " visible";
        if (args[0] == "sharktimer")
            return "Shark respawn timer is " + (setSharkTimer(true) ? "now" : "already") + " visible";
        if (args[0] == "fullhealth")
            return "Full health bars are " + (setFullBars(true) ? "now" : "already") + " visible";
        if (args[0] == "objective")
            return "Story objective is " + (setShowObjective(true) ? "now" : "already") + " visible";
        if (args[0] == "uses")
            return "Remaining item uses are " + (setShowUses(true) ? "now" : "already") + " visible";
        if (args[0] == "statdecimals")
            return "Stat numbers are " + (setStatDeci(true) ? "no longer" : "already not") + " rounded";
        if (args[0] == "equipment")
            return "Equipment is " + (setHUDEquip(true) ? "now" : "already") + " visible";
        if (args[0] == "weight")
            return "Raft foundation count is " + (setShowWeight(true) ? "now" : "already") + " visible";
        return args[0] + " is not a valid GUI aspect name";
    }

    [ConsoleCommand(name: "hide", docs: "Syntax: 'hide <GUI Aspect>'  Disables a part of the Statistic Mod GUI elements")]
    public static string MyCommand5(string[] args)
    {
        if (args.Length < 1)
            return "Not enough arguments";
        if (args.Length > 1)
            return "Too many arguments";
        args[0] = args[0].ToLower();
        if (args[0] == "weather")
            return "Weather is " + (setWeatherVisible(false) ? "now" : "already") + " hidden";
        if (args[0] == "sharktimer")
            return "Shark respawn timer is " + (setSharkTimer(false) ? "now" : "already") + " hidden";
        if (args[0] == "fullhealth")
            return "Full health bars are " + (setFullBars(false) ? "now" : "already") + " hidden";
        if (args[0] == "objective")
            return "Story objective is " + (setShowObjective(false) ? "now" : "already") + " hidden";
        if (args[0] == "uses")
            return "Remaining item uses are " + (setShowUses(false) ? "now" : "already") + " hidden";
        if (args[0] == "statdecimals")
            return "Stat numbers are " + (setStatDeci(false) ? "now" : "already") + " rounded";
        if (args[0] == "equipment")
            return "Equipment is " + (setHUDEquip(false) ? "now" : "already") + " hidden";
        if (args[0] == "weight")
            return "Raft foundation count is " + (setShowWeight(false) ? "now" : "already") + " hidden";
        return args[0] + " is not a valid GUI aspect name";
    }

    [ConsoleCommand(name: "guiAspects", docs: "Lists the names of the Statistic Mod GUI elements that can be toggled with 'show' and 'hide'")]
    public static string MyCommand6(string[] args)
    {
        return "weather\nsharktimer\nfullhealth\nobjective\nuses\nstatdecimals\nequipment\nweight";
    }

    [ConsoleCommand(name: "healthDrawDistance", docs: "Syntax: 'healthDrawDistance <distance>'  Changes how far away health bars can be seen from")]
    public static string MyCommand7(string[] args)
    {
        if (args.Length < 1)
            return "Not enough arguments";
        if (args.Length > 1)
            return "Too many arguments";
        try
        {
            barDrawDistance = float.Parse(args[0]);
            saveJson(Config);
            return "Can now see health bars from " + args[0];
        }
        catch
        {
            return "Cannot parse " + args[0] + " as a number";
        }
    }

    [ConsoleCommand(name: "setHUDPosition", docs: "Syntax: 'setHUDPosition <x> <y>'  Changes the location, of the extra HUD information, on the screen")]
    public static string MyCommand8(string[] args)
    {
        if (args.Length < 2)
            return "Not enough arguments";
        if (args.Length > 2)
            return "Too many arguments";
        try
        {
            float tmp = float.Parse(args[1]);
            HUDPositionX = float.Parse(args[0]);
            HUDPositionY = tmp;
            saveJson(Config);
            return "HUD has been moved";
        }
        catch
        {
            return "Failed to parse either " + args[0] + " or " + args[1] + " as a number";
        }
    }

    [ConsoleCommand(name: "setHUDToMouse", docs: "Sets the location, of the extra HUD information, on the screen to the location of the mouse")]
    public static string MyCommand9(string[] args)
    {
        HUDPositionX = Input.mousePosition.x / aspectRatio;
        HUDPositionY = canvas.GetComponent<RectTransform>().sizeDelta.y - Input.mousePosition.y;
        saveJson(Config);
        return "HUD has been moved";
    }

    private static string ToTitle(string str)
    {
        if (str.Length == 0)
            return "";
        if (str.Length == 1)
            return str.ToUpper();
        return str.Substring(0, 1).ToUpper() + str.Substring(1).ToLower();
    }

    public static void SetDamage(float amount)
    {
        dmgText.text = (-amount).ToString();
        dmgText.color = amount < 0 ? Color.green : Color.red;
        dmgTime = 0;
        dmgObject.SetActiveSafe(true);
    }

    private static JSONObject getSaveJson()
    {
        JSONObject data;
        try
        {
            data = new JSONObject(File.ReadAllText(configPath));
        }
        catch
        {
            data = JSONObject.Create();
            saveJson(data);
        }
        return data;
    }

    private static void saveJson(JSONObject data)
    {
        try
        {
            File.WriteAllText(configPath, data.ToString());
        }
        catch (Exception err)
        {
            Log("An error occured while trying to save settings: " + err.Message);
        }
    }

    public static bool hasExclusion(string name)
    {
        JSONObject list = exclusions;
        if (list.IsNull)
            return false;
        foreach (JSONObject tag in list.list)
        {
            if (tag.str == name)
                return true;
        }
        
        return false;
    }

    private static bool addExclusion(string name)
    {
        JSONObject list = exclusions;
        if (!list.IsNull)
        {
            foreach (JSONObject tag in list.list)
            {
                if (tag.str == name)
                    return false;
            }
        }
        list.Add(name);
        exclusions = list;
        saveJson(Config);
        return true;
    }

    private static bool removeExclusion(string name)
    {
        JSONObject list = exclusions;
        if (list.IsNull)
            return false;
        foreach (JSONObject tag in list.list)
        {
            if (tag.str == name)
            {
                list.list.Remove(tag);
                exclusions = list;
                saveJson(Config);
                return true;
            }
        }
        return false;
    }

    private static bool setFullBars(bool visible)
    {
        if (showFullBars == visible)
            return false;
        showFullBars = visible;
        saveJson(Config);
        return true;
    }

    private static bool setWeatherVisible(bool visible)
    {
        if (showWeather == visible)
            return false;
        showWeather = visible;
        saveJson(Config);
        return true;
    }

    private static bool setSharkTimer(bool visible)
    {
        if (showSharkRespawn == visible)
            return false;
        showSharkRespawn = visible;
        saveJson(Config);
        return true;
    }

    private static bool setShowObjective(bool visible)
    {
        if (showStoryObjective == visible)
            return false;
        showStoryObjective = visible;
        saveJson(Config);
        return true;
    }

    private static bool setShowUses(bool visible)
    {
        if (showDurability == visible)
            return false;
        showDurability = visible;
        saveJson(Config);
        return true;
    }

    private static bool setStatDeci(bool visible)
    {
        if (roundStats != visible)
            return false;
        roundStats = !visible;
        saveJson(Config);
        return true;
    }

    private static bool setHUDEquip(bool visible)
    {
        if (showHUDEquipment == visible)
            return false;
        showHUDEquipment = visible;
        saveJson(Config);
        return true;
    }

    private static bool setShowWeight(bool visible)
    {
        if (showFoundations == visible)
            return false;
        showFoundations = visible;
        saveJson(Config);
        return true;
    }

    public static string getNextStoryLocation()
    {
        if (RAPI.GetLocalPlayer() == null)
            return "Player not found";
        int ind = -1;
        NoteBookUI book = RAPI.GetLocalPlayer().NoteBookUI;
        foreach (NoteBookNote note in book.GetAllNotes())
        {
            if (note.isUnlocked)
                ind = Math.Max(storyNotes.IndexOf(note.noteIndex), ind);
        }
        return objectiveNames[ind + 1];
    }
}

[HarmonyPatch(typeof(Battery), "OnIsRayed")]
public class Patch_BatteryRayed
{
    public static ItemInstance batteryInstance;
    static void Prefix(ref Battery __instance)
    {
        batteryInstance = Traverse.Create(__instance).Field("batteryInstance").GetValue<ItemInstance>();
    }
    static void Postfix()
    {
        batteryInstance = null;
    }
}

[HarmonyPatch(typeof(DisplayTextManager), "ShowText", new Type[] { typeof(string), typeof(KeyCode), typeof(int), typeof(int), typeof(bool) })]
public class Patch_BatteryDisplayText
{
    static void Prefix(ref string text)
    {
        if (Patch_BatteryRayed.batteryInstance != null)
            text += "\n" + Patch_BatteryRayed.batteryInstance.Uses * 100 / Patch_BatteryRayed.batteryInstance.baseItem.MaxUses + "%";
    }
}

[HarmonyPatch(typeof(Pickup), "Update")]
public class Patch_LookingUpdate
{
    static bool shown = false;
    static void Postfix(ref Pickup __instance)
    {
        RaycastHit raycastHit;
        if (Helper.HitAtCursor(out raycastHit, Player.UseDistance, LayerMasks.MASK_Item) || Helper.HitAtCursor(out raycastHit, Player.UseDistance, LayerMasks.MASK_RaycastInteractable))
        {
            Plant crop = raycastHit.transform.GetComponent<Plant>();
            if (crop == null)
            {
                BoxCollider hitBox = raycastHit.transform.GetComponent<BoxCollider>();
                if (hitBox != null)
                {
                    Plant tree = hitBox.GetComponentInParent<Plant>();
                    if (tree != null)
                    {
                        showPlantProgress(tree);
                        return;
                    }
                }
            }
            else
            {
                showPlantProgress(crop);
                return;
            }
        }
        if (shown)
        {
            StatisticMod.canvas.displayTextManager.HideDisplayTexts();
            shown = false;
        }
    }

    static void showPlantProgress(Plant target)
    {
        if (target.FullyGrown())
            return;
        float growTime = target.GetGrowTimer() / Traverse.Create(target).Field("growTimeSec").GetValue<float>() * 100;
        if (growTime < 100)
        {
            shown = true;
            StatisticMod.showCrosshairText(Mathf.Floor(growTime).ToString() + "%");
        }
    }
}

[HarmonyPatch(typeof(CanvasHelper), "Start")]
public class Patch_CreateUI
{
    static void Postfix(ref CanvasHelper __instance)
    {
        GameObject display = StatisticMod.CreateText(__instance.transform, -500 * StatisticMod.aspectRatio, 350, "\nIf you can see this something has gone wrong", __instance.dropText.fontSize, __instance.dropText.color, 400, 300, __instance.dropText.font, "aTimeDisplay");
        StatisticMod.CopyTextShadow(display, __instance.dropText.gameObject);
        StatisticMod.time = new TimeBar(display, __instance.dropText.font.lineHeight,50,25);
        display.transform.SetAsFirstSibling();
        StatisticMod.dmgDisplay = StatisticMod.CreateText(__instance.transform, 130, 0, "0", __instance.dropText.fontSize, Color.red, 200, __instance.dropText.fontSize * 1.5f, __instance.dropText.font, "aDmgDisplay");
        StatisticMod.CopyTextShadow(StatisticMod.dmgDisplay, __instance.dropText.gameObject);
        StatisticMod.dmgDisplay.transform.SetAsFirstSibling();
        StatisticMod.dmgDisplay.SetActiveSafe(false);
        RectTransform Box = __instance.healthSlider.GetComponent<RectTransform>();
        GameObject stat = StatisticMod.CreateText(__instance.healthSlider.transform, 0, 0, "??/??", __instance.dropText.fontSize, __instance.dropText.color, 175, 50, __instance.dropText.font, "aStatDisplay");
        StatisticMod.AddTextShadow(stat, Color.black, new Vector2(2, -2));
        StatisticMod.statHeT = stat.GetComponent<Text>();
        Box = __instance.hungerSlider.GetComponent<RectTransform>();
        stat = StatisticMod.CreateText(__instance.hungerSlider.transform, 0, 0, "??/??", __instance.dropText.fontSize, new Color(0,0.5f,0), 175, 50, __instance.dropText.font, "aStatDisplay");
        StatisticMod.AddTextShadow(stat, Color.black, new Vector2(2, -2));
        StatisticMod.statHuT = stat.GetComponent<Text>();
        Box = __instance.thirstSlider.GetComponent<RectTransform>();
        stat = StatisticMod.CreateText(__instance.thirstSlider.transform, 0, 0, "??/??", __instance.dropText.fontSize, new Color(0.2f, 0.5f, 0.9f), 175, 50, __instance.dropText.font, "aStatDisplay");
        StatisticMod.AddTextShadow(stat, Color.black, new Vector2(2, -2));
        StatisticMod.statThT = stat.GetComponent<Text>();
        StatisticMod.sharkI = new sharkIndicator();
        StatisticMod.sharkTime = 0;
    }
}

[HarmonyPatch(typeof(CanvasHelper), "Update")]
public class Patch_UpdateUI
{
    static void Postfix(ref CanvasHelper __instance)
    {
        float timePassed = Time.deltaTime;
        WeatherManager wm = ComponentManager<WeatherManager>.Value;
        AzureSkyController sc = ComponentManager<AzureSkyController>.Value;
        Text GUIText = GetText(__instance, "aTimeDisplay");
        if (StatisticMod.sharkTime > 0)
            StatisticMod.sharkTime -= timePassed;
        if (GUIText != null && wm != null && sc != null && wm.GetCurrentWeather() != null)
        {
            Vector2 screenSize = __instance.GetComponent<RectTransform>().sizeDelta;
            StatisticMod.time.Update(sc.timeOfDay.hour);
            int cl = StatisticMod.clockSetting;
            StatisticMod.time.SetActive(!StatisticMod.timeIsClock && cl != 0);
            GUIText.rectTransform.localPosition = new Vector2(StatisticMod.HUDPositionX * StatisticMod.aspectRatio + 200 - screenSize.x / 2, screenSize.y / 2 - StatisticMod.HUDPositionY - 150);
            GUIText.text = (StatisticMod.clockSetting == 0 ? "" : ("Time: " + (StatisticMod.timeIsClock ? GetTimeString(sc.timeOfDay.hour) : "") + "\n")) + (StatisticMod.showWeather ? "Weather: " + GetWeatherString(wm.GetCurrentWeather().so_weather.weatherType) + "\n" : "") + (StatisticMod.showFoundations ? "Foundation Count: " + Traverse.Create<BlockCreator>().Field("raftBounds").GetValue<RaftBounds>().FoundationCount + " (Needs " + Math.Ceiling(RaftWeightManager.FoundationWeight / 100f) + " Engine" + (RaftWeightManager.FoundationWeight / 100 == 0 ? "" : "s") + ")\n" : "") + ((StatisticMod.sharkTime > 0 && StatisticMod.showSharkRespawn) ? "Shark respawning in: " + GetTimeString(StatisticMod.sharkTime / 60,false) + "\n" : "") + (StatisticMod.showStoryObjective ? "\nNext Story Location: " + StatisticMod.getNextStoryLocation() : "");
        }
        foreach (HealthBar bar in StatisticMod.bars)
            bar.UpdateFacing();
        for (int i = StatisticMod.pops.Count - 1;i >= 0;i--)
            StatisticMod.pops[i].Update();
        StatisticMod.dmgTime += timePassed;
        if (StatisticMod.dmgDisplay.activeSelf)
        {
            StatisticMod.dmgOffset.anchoredPosition = StatisticMod.dmgStart + new Vector2(StatisticMod.dmgTime, 0) * 100;
            StatisticMod.dmgText.color = new Color(StatisticMod.dmgText.color.r, StatisticMod.dmgText.color.g, StatisticMod.dmgText.color.b, 1 - StatisticMod.dmgTime);
            if (StatisticMod.dmgText.color.a <= 0)
                StatisticMod.dmgDisplay.SetActiveSafe(false);
        }
        Network_Player player = RAPI.GetLocalPlayer();
        if (player != null)
        {
            for (int i = 0;i < StatisticMod.equipDisplay.Count;i++)
                StatisticMod.equipDisplay[i].Update(i);
            PlayerStats Stats = player.Stats;
            StatisticMod.statHeT.text = Math.Round(Stats.stat_health.Value, StatisticMod.roundStats ? 0 : 1).ToString() + "/" + Math.Round(Stats.stat_health.Max, StatisticMod.roundStats ? 0 : 1).ToString();
            StatisticMod.statHuT.text = Math.Round(Stats.stat_hunger.Normal.Value, StatisticMod.roundStats ? 0 : 1).ToString() + "/" + Math.Round(Stats.stat_hunger.Normal.Max, StatisticMod.roundStats ? 0 : 1).ToString() + (Stats.stat_hunger.Bonus.Value > 0 ? " + " + Math.Round(Stats.stat_hunger.Bonus.Value, StatisticMod.roundStats ? 0 : 1).ToString() : "");
            StatisticMod.statThT.text = Math.Round(Stats.stat_thirst.Value, StatisticMod.roundStats ? 0 : 1).ToString() + "/" + Math.Round(Stats.stat_thirst.Max, StatisticMod.roundStats ? 0 : 1).ToString();
            if (StatisticMod.updatePlayerHealth)
                foreach (KeyValuePair<CSteamID, Network_Player> pair in player.Network.remoteUsers.ToArray())
                    if (pair.Value != player)
                        RAPI.SendNetworkMessage(new healthCall(Stats.stat_health.Value), healthCall.ChannelID);
        }
        StatisticMod.sharkI.Update();
    }

    static Text GetText(CanvasHelper canvas, string name)
    {
        foreach (Text gO in canvas.GetComponentsInChildren<Text>())
        {
            if (gO.name == name)
                return gO;
        }
        return null;
    }

    static string GetTimeString(float TimeOfDay, bool addZero = true)
    {
        int hour = (int)TimeOfDay;
        int minute = (int)((TimeOfDay - hour) * 60);
        if (addZero)
            return hour.ToString().PadLeft(2, '0') + ":" + minute.ToString().PadLeft(2, '0');
        return hour.ToString() + ":" + minute.ToString().PadLeft(2, '0');
    }

    static string GetWeatherString(WeatherType type)
    {
        if (type == WeatherType.Default)
        {
            return "Normal";
        }
        else
            return type.ToString();
    }
}

[HarmonyPatch(typeof(Network_Entity), "Update")]
public class Patch_CreatureUpdate
{
    static void Postfix(ref Network_Entity __instance)
    {
        int ind = StatisticMod.ents.IndexOf(__instance);
        if (ind > -1)
            StatisticMod.bars[ind].Update();
    }
}

[HarmonyPatch(typeof(PlayerEquipment), "Equip")]
public class Patch_AddEquipment
{
    static void Postfix(ref PlayerEquipment __instance, ref ItemInstance item, ref Slot_Equip slot)
    {
        Network_Player player = Traverse.Create(__instance).Field("playerNetwork").GetValue<Network_Player>();
        int ind = player.Inventory.equipSlots.IndexOf(slot);
        if (item.BaseItemMaxUses > 1)
        {
            HUDEquipmentDisplay newDisplay = new HUDEquipmentDisplay(StatisticMod.canvas, player.Inventory.equipSlots[ind], player.Inventory.slotPrefab, new Vector2(10, 200), ind, player.Inventory.gridLayoutGroup.cellSize);
            for (int i = 0; i < StatisticMod.equipDisplay.Count; i++)
                if (StatisticMod.equipDisplay[i].slotIndex < ind)
                {
                    StatisticMod.equipDisplay.Insert(i, newDisplay);
                    return;
                }
            StatisticMod.equipDisplay.Add(newDisplay);
        }

    }
}

[HarmonyPatch(typeof(PlayerEquipment), "UnEquip")]
public class Patch_RemoveEquipment
{
    static void Postfix(ref PlayerEquipment __instance, ref ItemInstance item)
    {
        for (int i = StatisticMod.equipDisplay.Count - 1; i >= 0; i--)
            if (StatisticMod.equipDisplay[i].parentSlot.itemInstance == null || StatisticMod.equipDisplay[i].parentSlot.itemInstance.BaseItemMaxUses <= 1)
            {
                StatisticMod.equipDisplay[i].Destroy();
                StatisticMod.equipDisplay.RemoveAt(i);
            }
    }
}

[HarmonyPatch(typeof(MonoBehaviour_ID), "OnDestroy")]
public class Patch_CreatureDestroy
{
    static void Prefix(ref MonoBehaviour_ID __instance)
    {
        if (__instance is Network_Entity)
        {
            int ind = StatisticMod.ents.IndexOf(__instance as Network_Entity);
            if (ind >= 0)
            {
                StatisticMod.bars.RemoveAt(ind);
                StatisticMod.ents.RemoveAt(ind);
            }
        }
    }
}

[HarmonyPatch(typeof(Network_Entity), "Start")]
public class Patch_CreatureCreation
{
    static void Postfix(ref Network_Entity __instance)
    {
        if (RAPI.GetLocalPlayer().gameObject == __instance.gameObject)
            return;
        new HealthBar(__instance);
    }
}

[HarmonyPatch(typeof(Network_Entity), "Damage")]
public class Patch_CreatureDamage
{
    static void Postfix(ref Network_Entity __instance, ref float damage, ref Vector3 hitPoint)
    {
        if (RAPI.GetLocalPlayer().gameObject == __instance.gameObject)
        {
            StatisticMod.SetDamage(damage);
            return;
        }
        new damageIndicator(__instance.transform, damage, hitPoint);
    }
}

[HarmonyPatch(typeof(ItemInstance_Inventory), "Description", MethodType.Getter)]
public class Patch_ItemDescription
{
    static void Postfix(ref ItemInstance_Inventory __instance, ref string __result)
    {
        List<Item_Base> items = ItemManager.GetAllItems();
        foreach (Item_Base item in items)
            if (item.settings_Inventory == __instance)
            {
                MeleeWeapon weapon = null;
                foreach (ItemConnection connect in RAPI.GetLocalPlayer().PlayerItemManager.useItemController.allConnections)
                    if (connect.inventoryItem == item)
                    {
                        weapon = connect.obj.GetComponent<MeleeWeapon>();
                        break;
                    }
                if (item.settings_consumeable != null && (item.settings_consumeable.HungerYield != 0 || item.settings_consumeable.BonusHungerYield != 0 || item.settings_consumeable.ThirstYield != 0 || weapon != null))
                    __result += "\n" + (item.settings_consumeable.HungerYield != 0 ? "\nFood: " + item.settings_consumeable.HungerYield.ToString() : "")
                        + (item.settings_consumeable.BonusHungerYield != 0 ? "\nFood Bonus: " + item.settings_consumeable.BonusHungerYield.ToString() : "")
                        + (item.settings_consumeable.ThirstYield != 0 ? "\nWater: " + item.settings_consumeable.ThirstYield.ToString() : "")
                        + (weapon != null ? "\nDamage: " + Traverse.Create(weapon).Field("damage").GetValue<int>().ToString() : "");
                break;
            }
    }
}

[HarmonyPatch(typeof(AI_State_Attack_Block_Shark), "InitiateAttackOnBlock")]
public class Patch_SharkAttackRaft
{
    static void Postfix(ref Block p_targetBlock)
    {
        StatisticMod.sharkI.StartAttack(p_targetBlock.transform);
    }
}

[HarmonyPatch(typeof(AI_State_Attack_Block_Shark), "ExitState")]
public class Patch_SharkStopAttackRaft
{
    static void Postfix()
    {
        StatisticMod.sharkI.StopAttack();
    }
}

[HarmonyPatch(typeof(Network_Host_Entities), "CreateShark")]
public class Patch_SharkRespawnStart
{
    static void Prefix(float timeDelay)
    {
        StatisticMod.sharkTime = timeDelay;
    }
}

[HarmonyPatch(typeof(Inventory), "Start")]
public class Patch_InventoryDisplayCreate
{
    static void Postfix(ref Inventory __instance)
    {
        duraText newObj = __instance.gameObject.AddComponent<duraText>();
        newObj.container = StatisticMod.CreateText(__instance.gameObject.transform, 0, 0, "hi", StatisticMod.canvas.dropText.fontSize, StatisticMod.canvas.dropText.color, 0.2f * Screen.height, 50, StatisticMod.canvas.dropText.font,"duraText");
        newObj.textComponent = newObj.container.GetComponent<Text>();
        StatisticMod.CopyTextShadow(newObj.container, StatisticMod.canvas.dropText.gameObject);
        newObj.textComponent.gameObject.SetActive(false);
    }
}

[HarmonyPatch(typeof(Inventory), "HoverEnter")]
public class Patch_InventoryStartHover
{
    static void Postfix(ref Inventory __instance, ref Slot slot)
    {
        if (!slot.IsEmpty && slot.itemInstance.BaseItemMaxUses > 1)
        {
            duraText obj = __instance.gameObject.GetComponent<duraText>();
            if (obj != null)
            {
                obj.textComponent.gameObject.SetActive(true);
                obj.textComponent.text = slot.GetCurrentTotalUses().ToString() + "/" + slot.GetMaxStackUses().ToString();
            }
        }
    }
}

[HarmonyPatch(typeof(Inventory), "HoverExit")]
public class Patch_InventoryEndHover
{
    static void Postfix(ref Inventory __instance)
    {
        duraText obj = __instance.gameObject.GetComponent<duraText>();
        if (obj != null && StatisticMod.showDurability)
        {
            obj.textComponent.gameObject.SetActive(false);
        }
    }
}

[HarmonyPatch(typeof(Inventory), "Update")]
public class Patch_InventoryUpdate
{
    static void Postfix(ref Inventory __instance)
    {
        duraText obj = __instance.gameObject.GetComponent<duraText>();
        if (obj != null)
        {
            obj.textComponent.transform.position = Input.mousePosition;
            obj.textComponent.rectTransform.localPosition += new Vector3(0.12f * Screen.height, 0);
            obj.textComponent.rectTransform.sizeDelta = new Vector2(0.2f * Screen.height, 50);
        }
    }
}


public class UILine : Image
{
    private Vector2 _p;
    private Vector2 _s;
    private float _a;
    private static Vector2 _cP;
    private static Vector2 _cS;
    private static float _cA;
    public Vector2 start
    {
        get
        {
            return _p;
        }
        set
        {
            _p = value;
            UpdatePosition();
        }
    }
    public float length
    {
        get
        {
            return _s.x;
        }
        set
        {
            _s.x = value;
            UpdatePosition();
        }
    }
    public float angle
    {
        get
        {
            return _a;
        }
        set
        {
            _a = value;
            UpdatePosition();
        }
    }
    public float width
    {
        get
        {
            return _s.y;
        }
        set
        {
            _s.y = value;
            UpdatePosition();
        }
    }
    private UILine()
    {
        _p = _cP;
        _s = _cS;
        _a = _cA;
    }
    protected override void Start()
    {
        base.Start();
        UpdatePosition();
    }
    private void UpdatePosition()
    {
        rectTransform.localRotation = Quaternion.Euler(0, 0, _a);
        rectTransform.pivot = new Vector2(_s.y / 2f / _s.x, 0.5f);
        rectTransform.localPosition = _p;
        rectTransform.sizeDelta = _s;
    }
    public static void setCreationValues(Vector2 start, float lineLength, float lineWidth, float lineAngle)
    {
        _cP = start;
        _cS = new Vector2(lineLength, lineWidth);
        _cA = lineAngle;
    }
}

public class HealthBar
{
    private Canvas canvas;
    private UILine green;
    private Text numDisplay;
    private float barlength;
    Network_Entity parent;
    GameObject container;
    public float health;
    public float maxHealth;

    public HealthBar(Network_Entity creature)
    {
        parent = creature;
        container = new GameObject();
        container.transform.SetParent(parent.transform, false);
        container.transform.localPosition = new Vector3(0, 2, 0);
        RectTransform rect = container.AddComponent<RectTransform>();
        rect.sizeDelta = new Vector2(1, 1f);
        canvas = container.AddComponent<Canvas>();
        canvas.transform.SetParent(container.transform, false);
        canvas.transform.localScale = new Vector3(0.001f, 0.001f, 0.001f);
        RectTransform trans = canvas.GetComponent<RectTransform>();
        trans.sizeDelta = new Vector2(1, 1f);
        barlength = 300;
        float lineWidth = 50;
        float textWidth = 300;
        float borderSize = 10;
        StatisticMod.CreateLine(canvas, barlength + borderSize * 2, lineWidth + borderSize * 2, lineWidth / 2 - barlength / 2, 0, Color.grey, 0).GetComponent<UILine>();
        StatisticMod.CreateLine(canvas, barlength, lineWidth, lineWidth / 2 - barlength / 2, 0, new Color(0.8f,0,0), 0).GetComponent<UILine>();
        green = StatisticMod.CreateLine(canvas, 0, lineWidth, lineWidth / 2 - barlength / 2, 0, Color.green, 0).GetComponent<UILine>();
        numDisplay = StatisticMod.CreateText(container.transform, (barlength / 2 + textWidth / 2 + borderSize + 15), -15, "??? / ???", (int)lineWidth, StatisticMod.canvas.dropText.color, textWidth, lineWidth * 2, StatisticMod.canvas.dropText.font).GetComponent<Text>();
        StatisticMod.CopyTextShadow(numDisplay.gameObject, StatisticMod.canvas.dropText.gameObject);
        health = parent.stat_health.Value;
        maxHealth = parent.stat_health.Max;
        StatisticMod.bars.Add(this);
        StatisticMod.ents.Add(parent);
        Shadow shad = container.AddComponent<Shadow>();
        shad.effectColor = Color.black;
        shad.effectDistance = Vector2.zero;
        shad.useGraphicAlpha = false;
    }

    public void Update()
    {
        health = parent.stat_health.Value;
        maxHealth = parent.stat_health.Max;
        green.length = barlength * health / maxHealth;
        numDisplay.text = ((int)health).ToString() + " / " + ((int)maxHealth).ToString();
    }

    public void UpdateFacing()
    {
        Vector3 dirVec = Helper.MainCamera.transform.position - canvas.transform.position;
        float angle = Mathf.Acos(dirVec.z / dirVec.XZOnly().magnitude) / (float)Math.PI * 180f + 180;
        container.transform.rotation = Quaternion.Euler(0, dirVec.x < 0 ? -angle : angle, 0);
        container.SetActive(dirVec.magnitude < StatisticMod.barDrawDistance && !StatisticMod.hasExclusion(CleanName(parent.name).ToLower()) && (StatisticMod.showFullBars || health < maxHealth));
    }

    public string CleanName(string entityName)
    {
        if (entityName.EndsWith("(Clone)"))
            entityName = entityName.Substring(0, entityName.Length - 7);
        if (entityName.StartsWith("AI_"))
            entityName = entityName.Remove(0, 3);
        return entityName;
    }
}

public class TimeBar
{
    private GameObject container;
    private Canvas canvas;
    private UILine colored;
    private UILine fading;
    private float barlength;
    private static Color night = new Color(0, 0, 0.4f);
    private static Color day = new Color(0.3f,0.6f,1);
    private static float sunrise = 4;
    private static float sunset = 20;

    public TimeBar(GameObject parent, int fontSize, float X, float Y)
    {
        container = new GameObject();
        container.transform.SetParent(parent.transform,false);
        RectTransform transObj = container.AddComponent<RectTransform>();
        transObj.sizeDelta = parent.GetComponent<RectTransform>().sizeDelta;
        canvas = container.AddComponent<Canvas>();
        canvas.transform.SetParent(container.transform, false);
        RectTransform trans = canvas.GetComponent<RectTransform>();
        barlength = fontSize * 3;
        float lineWidth = fontSize;
        float border = 3;
        float barX = lineWidth / 2 - trans.sizeDelta.x / 2 + border + X;
        float barY = lineWidth / 2 + trans.sizeDelta.y / 2 + border - Y;
        StatisticMod.CreateLine(canvas, barlength + border * 2, lineWidth + border * 2, barX, barY, Color.grey, 0).GetComponent<UILine>();
        colored = StatisticMod.CreateLine(canvas, barlength, lineWidth, barX, barY, Color.black, 0).GetComponent<UILine>();
        fading = StatisticMod.CreateLine(canvas, barlength / 2, lineWidth, barX, barY, Color.yellow, 0).GetComponent<UILine>();
    }

    public void Update(float TimeOfDay)
    {
        if (TimeOfDay >= sunrise && TimeOfDay < sunset)
        {
            TimeOfDay -= sunrise;
            colored.color = day;
            fading.color = night;
            fading.length = barlength * TimeOfDay / (sunset - sunrise);
        } else
        {
            TimeOfDay -= sunset;
            if (TimeOfDay < 0)
                TimeOfDay += 24;
            colored.color = night;
            fading.color = day;
            fading.length = barlength * TimeOfDay / (24 - sunset + sunrise);
        }
    }

    public void UpdatePosition()
    {
        RectTransform trans = canvas.GetComponent<RectTransform>();

    }

    public void SetActive(bool active)
    {
        container.SetActive(active);
    }
}

public class damageIndicator
{
    private GameObject container;
    private Vector3 startPos;
    private Vector3 angle;
    private float timePassed;
    private Text numDisplay;
    public damageIndicator(Transform init, float amount, Vector3 hitPos)
    {
        amount = -amount;
        container = new GameObject();
        container.transform.SetParent(init,false);
        container.transform.parent = null;
        startPos = container.transform.position;
        startPos.y += 1;
        RectTransform rect = container.AddComponent<RectTransform>();
        rect.sizeDelta = new Vector2(1, 1f);
        float scaler = 100;
        Canvas canvas = container.AddComponent<Canvas>();
        canvas.transform.SetParent(container.transform, false);
        canvas.transform.localScale = new Vector3(0.1f, 0.1f, 0.1f) / scaler;
        RectTransform trans = canvas.GetComponent<RectTransform>();
        trans.sizeDelta = new Vector2(1, 1f);
        GameObject obj = StatisticMod.CreateText(container.transform, 0, 0, damageString(amount), (int)(2 * scaler), amount >= 0 ? Color.green : Color.red, 5 * scaler, 5 * scaler, StatisticMod.canvas.dropText.font);
        StatisticMod.CopyTextShadow(obj, StatisticMod.canvas.dropText.gameObject);
        numDisplay = obj.GetComponent<Text>();
        double a = new System.Random().NextDouble() * 2 * Math.PI;
        angle = new Vector3((float)Math.Cos(a),0,(float)Math.Sin(a));
        StatisticMod.pops.Add(this);
    }
    public void Update()
    {
        timePassed += Time.deltaTime * 1.5f;
        Vector3 newPos = startPos + angle * timePassed;
        newPos.y += (float)(Math.Pow(1, 2) - Math.Pow(timePassed-1,2)) / 2;
        container.transform.position = newPos;
        Vector3 dirVec = Helper.MainCamera.transform.position - container.transform.position;
        float a = Mathf.Acos(dirVec.z / dirVec.XZOnly().magnitude) / (float)Math.PI * 180f + 180;
        container.transform.rotation = Quaternion.Euler(0, dirVec.x < 0 ? -a : a, 0);
        numDisplay.color = new Color(numDisplay.color.r, numDisplay.color.g, numDisplay.color.b, 1 - timePassed / 3);
        if (numDisplay.color.a <= 0)
            Destroy();
    }
    private string damageString(float amount)
    {
        return (amount > 0 ? "+" : "") + ((int)amount).ToString();
    }
    public void Destroy()
    {
        StatisticMod.pops.Remove(this);
        GameObject.Destroy(container);
    }
}

public class sharkIndicator
{
    private Transform position;
    private float timePassed;
    private GameObject container;
    private Text alert;
    private bool attacking;
    public sharkIndicator()
    {
        timePassed = 0;
        RectTransform rect = StatisticMod.canvas.GetComponent<RectTransform>();
        container = StatisticMod.CreateText(StatisticMod.canvas.transform, rect.sizeDelta.x * rect.localScale.x * 0.45f, rect.sizeDelta.y * rect.localScale.y * 0.45f, "alert", StatisticMod.canvas.dropText.fontSize * 2, Color.red, rect.sizeDelta.x * rect.localScale.x * 0.06f, StatisticMod.canvas.dropText.fontSize * 3, StatisticMod.canvas.dropText.font);
        StatisticMod.CopyTextShadow(container, StatisticMod.canvas.dropText.gameObject);
        alert = container.GetComponent<Text>();
        alert.transform.SetAsFirstSibling();
        attacking = false;
        container.SetActive(false);
    }
    public void StartAttack(Transform loc)
    {
        position = loc;
        attacking = true;
        timePassed = 0;
    }
    public void StopAttack()
    {
        attacking = false;
    }
    public void Update()
    {
        timePassed += Time.deltaTime;
        if (position != null)
        {
            container.SetActive(alert.transform.position.z > 0 && attacking);
            alert.transform.position = Helper.MainCamera.WorldToScreenPoint(position.position);
            alert.color = new Color(1, 0, 0, (float)Math.Sin(timePassed * 5) / 4 + 0.75f);
        }
    }
    public void Destroy()
    {
        GameObject.Destroy(container);
    }
}

public class duraText : MonoBehaviour
{
    public GameObject container;
    public Text textComponent;
}

public class healthCall : Message
{
    public const short ID = short.MaxValue - 5;
    public const int ChannelID = 127;
    public float health;
    public healthCall(float health) : base((Messages)ID)
    {
        this.health = health;
    }
}

public class HUDEquipmentDisplay
{
    public CanvasHelper canvas;
    public Slot displaySlot;
    public GameObject gameObject;
    public Slot parentSlot;
    public RectTransform rectTransform;
    private Vector2 basePosition;
    private Vector2 offset;
    public int slotIndex;
    public HUDEquipmentDisplay(CanvasHelper helper, Slot parentSlot, GameObject prefab, Vector2 basePosition, int slotIndex, Vector2 displaySize)
    {
        canvas = helper;
        this.parentSlot = parentSlot;
        gameObject = UnityEngine.Object.Instantiate(prefab,canvas.gameObject.transform);
        displaySlot = gameObject.GetComponent<Slot>();
        rectTransform = gameObject.GetComponent<RectTransform>();
        gameObject.transform.localScale = prefab.transform.localScale;
        rectTransform.localPosition = new Vector2(0, 0);
        rectTransform.sizeDelta = displaySize;
        offset = new Vector2(0, rectTransform.sizeDelta.y * 1.2f);
        this.basePosition = basePosition;
        this.slotIndex = slotIndex;
    }

    public void Update(int index)
    {
        gameObject.SetActiveSafe(CanvasHelper.ActiveMenu == MenuType.None && StatisticMod.showHUDEquipment);
        if (!gameObject.activeSelf)
            return;
        if (parentSlot.itemInstance != null)
            displaySlot.SetItem(parentSlot.itemInstance.Clone());
        Vector2 screenSize = StatisticMod.canvas.GetComponent<RectTransform>().sizeDelta;
        rectTransform.localPosition = new Vector2((basePosition.x + offset.x * index) * StatisticMod.aspectRatio - screenSize.x / 2, basePosition.y + offset.y * index - screenSize.y / 2 + rectTransform.sizeDelta.y);
    }

    public void Destroy()
    {
        UnityEngine.GameObject.Destroy(gameObject);
        UnityEngine.GameObject.Destroy(displaySlot.gameObject);
    }
}